Public = {}


local threat_values = {
	["small-spitter"] = 1.5,
	["small-biter"] = 1.5,
	["medium-spitter"] = 4.5,
	["medium-biter"] = 4.5,
	["big-spitter"] = 13,
	["big-biter"] = 13,
	["behemoth-spitter"] = 38.5,
	["behemoth-biter"] = 38.5,
	["small-worm-turret"] = 8,
	["medium-worm-turret"] = 16,
	["big-worm-turret"] = 24,
	["behemoth-worm-turret"] = 32,
	["biter-spawner"] = 32,
	["spitter-spawner"] = 32
}

local enemy_types = {
	"small-spitter",
	"small-biter",
	"medium-spitter",
	"medium-biter",
	"big-spitter",
	"big-biter",
	"behemoth-spitter",
	"behemoth-biter"
}


local function send_attack(threat)
	local surface = game.surfaces[1]
	local silo = surface.find_entities_filtered({position={0,-480}, raidus=100, name="rocket-silo"})
	local spawner = surface.find_entities_filtered({position={0,480}, raidus=100, name="biter-spawner"})

	local unit_group = surface.create_unit_group({position = {0, 470}, force = "enemy"})

	for _=1, 200, 1 do
		if threat < 0 then break end
		local enemy_type = enemy_types[math.random(1, #enemy_types)]
		threat = threat - 5*threat_values[enemy_type]
		for _=1, 5, 1 do
			local position = surface.find_non_colliding_position(enemy_type, spawner.position, 128, 2)
			if not position then break end
			local enemy = surface.create_entity({name = enemy_type, force = "enemy", position = position})
			unit_group.add_member(enemy)
		end
	end
	local commands = {}
	commands[#commands + 1] = {
		type = defines.command.attack,
		target = global.rocket_silo[force_name],
		distraction = defines.distraction.by_enemy
	}

	unit_group.set_command({
		type = defines.command.compound,
		structure_type = defines.compound_command.logical_and,
		commands = commands
	})
end
Public.send_attack = send_attack

return Public
